import 'dart:convert';
import 'dart:ui';
import 'package:flutter/services.dart';
import 'package:provider/provider.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:tencent_im_sdk_plugin/enum/V2TimAdvancedMsgListener.dart';
import 'package:tencent_im_sdk_plugin/enum/V2TimConversationListener.dart';
import 'package:tencent_im_sdk_plugin/enum/V2TimFriendshipListener.dart';
import 'package:tencent_im_sdk_plugin/enum/V2TimGroupListener.dart';
import 'package:tencent_im_sdk_plugin/enum/V2TimSDKListener.dart';
import 'package:tencent_im_sdk_plugin/enum/V2TimSignalingListener.dart';
import 'package:tencent_im_sdk_plugin/enum/V2TimSimpleMsgListener.dart';
import 'package:tencent_im_sdk_plugin/enum/log_level.dart';
import 'package:tencent_im_sdk_plugin/manager/v2_tim_manager.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_group_change_info.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_group_member_change_info.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_group_member_info.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_callback.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_friend_application.dart';

import 'package:tencent_im_sdk_plugin/models/v2_tim_friend_info.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_group_application_result.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_message.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_message_receipt.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_user_info.dart';
import 'package:tencent_im_sdk_plugin/tencent_im_sdk_plugin.dart';
import 'package:flutter/material.dart';
import 'package:dio/dio.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_value_callback.dart';

import 'package:tencent_im_sdk_plugin/models/v2_tim_user_full_info.dart';
import 'package:tencent_im_sdk_plugin_example/common/colors.dart';

import 'package:tencent_im_sdk_plugin_example/pages/home/home.dart';
import 'package:tencent_im_sdk_plugin_example/provider/conversion.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_conversation.dart';
import 'package:tencent_im_sdk_plugin_example/provider/currentMessageList.dart';
import 'package:tencent_im_sdk_plugin_example/provider/friend.dart';
import 'package:tencent_im_sdk_plugin_example/provider/friendApplication.dart';
import 'package:tencent_im_sdk_plugin_example/provider/groupApplication.dart';
import 'package:tencent_im_sdk_plugin_example/provider/user.dart';
// import 'package:tencent_im_sdk_plugin_example/utils/Config.dart';
import 'package:tencent_im_sdk_plugin_example/utils/GenerateTestUserSig.dart';
// import 'package:tencent_im_sdk_plugin_example/utils/GenerateTestUserSig.dart';
import 'package:tencent_im_sdk_plugin_example/utils/tools.dart';
// import 'package:tencent_tpns_oppo_push_plugin/enum/importance.dart';
// import 'package:tencent_tpns_oppo_push_plugin/tencent_tpns_oppo_push_plugin.dart';
// import 'package:tencent_tpns_vivo_push_plugin/tencent_tpns_vivo_push_plugin.dart';
// import 'package:tencent_tpns_xiaomi_push_plugin/tencent_tpns_xiaomi_push_plugin.dart';
import 'package:toast/toast.dart';
import 'package:webview_flutter/webview_flutter.dart';

var timLogo = AssetImage("images/logo.png");

class LoginPage extends StatefulWidget {
  @override
  _LoginPageState createState() => _LoginPageState();
}

class _LoginPageState extends State<LoginPage> {
  bool isinit = false;
  String oppoRegId;

  void initState() {
    super.initState();
    init();
  }

  init() async {
    await initSDK();
    await islogin();
    // await toHomePage();
  }

  offlinePushCallback(data) {
    if (data['name'] == 'onRegister') {
      if (data['responseCode'] == 0) {
        setState(() {
          oppoRegId = data['data'];
        });
        TencentImSDKPlugin.v2TIMManager
            .getOfflinePushManager()
            .setOfflinePushConfig(businessID: 7005, token: data['data'])
            .then((res) {
          if (res.code == 0) {
            Toast.show("设置推送成功", context);
          } else {
            Toast.show("设置推送失败${res.desc}", context);
          }
        }).catchError((err) {
          Toast.show("设置推送失败$err", context);
          print("设置推送失败$err");
        });
      }
    }
  }

  // initVivoPush() async {
  //   TencentTpnsVivoPushPlugin.initialize();
  //   String regId = await TencentTpnsVivoPushPlugin.getRegId();
  //   print('regId$regId');
  // }

  // initXiaomiPush() async {
  //   TencentTpnsXiaomiPushPlugin.registerPush(
  //     appID: "2882303761518516314",
  //     appToken: "5141851613314",
  //   );
  //   String regId = await TencentTpnsXiaomiPushPlugin.getRegId();
  //   TencentTpnsXiaomiPushPlugin.enablePush();
  //   if (regId.isNotEmpty) {
  //     TencentImSDKPlugin.v2TIMManager
  //         .getOfflinePushManager()
  //         .setOfflinePushConfig(businessID: 5218, token: regId)
  //         .then((res) {
  //       if (res.code == 0) {
  //         Toast.show("设置推送成功", context);
  //       } else {
  //         Toast.show("设置推送失败${res.desc}", context);
  //       }
  //     }).catchError((err) {
  //       Toast.show("设置推送失败$err", context);
  //       print("设置推送失败$err");
  //     });
  //   } else {
  //     Toast.show("获取小米regid失败", context);
  //   }
  // }

  // initOppoPush() async {
  //   TencentTpnsOppoPushPlugin.init(needLog: true);
  //   TencentTpnsOppoPushPlugin.setCallback(callback: offlinePushCallback);
  //   bool isSupport = await TencentTpnsOppoPushPlugin.isSupportPush();
  //   if (isSupport) {
  //     TencentTpnsOppoPushPlugin.createNotificationChannel(
  //       channel: "tuikit",
  //       name: "test",
  //       description: "test description",
  //       importance: Importance.IMPORTANCE_HIGH,
  //     );
  //     TencentTpnsOppoPushPlugin.register(
  //       appKey: "cf080880fc9747cf8f09baa6d806fb85",
  //       appSecret: "75bb981450bc4753b93b1978fd014c95",
  //     );
  //     TencentTpnsOppoPushPlugin.resumePush();
  //   }
  // }

  // TODO: 调试代码，上线删除
  // toHomePage() async {
  //   const userId = "lexuslin";
  //   var userSig = new GenerateTestUserSig(
  //     sdkappid: Config.sdkAppId,
  //     key: Config.secretKey
  //   ).genSig(identifier: userId, expire: 7*24*60000);
  //   var data = await TencentImSDKPlugin.v2TIMManager.login(
  //     userID: userId,
  //     userSig: userSig,
  //   );

  //   await Tools.setOfflinepush(context);

  //   var infos = await TencentImSDKPlugin.v2TIMManager
  //       .getUsersInfo(userIDList: [userId]);
  //   Provider.of<UserModel>(context, listen: false).setInfo(infos.data[0]);

  //   Navigator.push(
  //     context,
  //     new MaterialPageRoute(
  //       builder: (context) => HomePage(),
  //     ),
  //   );
  // }

  islogin() async {
    Future<SharedPreferences> _prefs = SharedPreferences.getInstance();
    SharedPreferences prefs = await _prefs;
    String token = prefs.getString("token");
    String sessionId = prefs.getString("sessionId");
    String phone = prefs.getString("phone");
    String code = prefs.getString("code");
    print("token$token");
    print("sessionId$sessionId");
    print("phone$phone");
    print("code$code");
    if (token != null && sessionId != null && phone != null && code != null) {
      Dio dio = new Dio();
      Response response = await dio.get(
        "https://service-c2zjvuxa-1252463788.gz.apigw.tencentcs.com/release/demoSms",
        queryParameters: {
          "phone": "86$phone",
          "method": "login",
          "sessionId": sessionId,
          "token": token,
          "code": code
        },
      );
      print(response);
      if (response.data['errorCode'] == 0) {
        //登录成功
        String userId = response.data['data']['userId'];
        String userSig = response.data['data']['userSig'];
        String avatar = response.data['data']['avatar'];

        V2TimCallback data = await TencentImSDKPlugin.v2TIMManager.login(
          userID: userId,
          userSig: userSig,
        );

        if (data.code != 0) {
          print('登录失败${data.desc}');
          setState(() {
            isinit = true;
          });
          return;
        } else {
          print("登录成功");
        }

        await Tools.setOfflinepush(context);

        V2TimValueCallback<List<V2TimUserFullInfo>> infos =
            await TencentImSDKPlugin.v2TIMManager
                .getUsersInfo(userIDList: [userId]);
        if (infos.code == 0) {
          if (infos.data[0].nickName == null ||
              infos.data[0].faceUrl == null ||
              infos.data[0].nickName == '' ||
              infos.data[0].faceUrl == '') {
            await TencentImSDKPlugin.v2TIMManager.setSelfInfo(
              userFullInfo: V2TimUserFullInfo.fromJson(
                {
                  "nickName": userId,
                  "faceUrl": avatar,
                },
              ),
            );
          }
          Provider.of<UserModel>(context, listen: false).setInfo(infos.data[0]);
        } else {}
        try {
          Navigator.of(context).push(
            new MaterialPageRoute(
              builder: (context) {
                return HomePage();
              },
            ),
          );
        } catch (err) {
          print(err);
        }
      } else {}
    } else {}
    setState(() {
      isinit = true;
    });
  }

  onRecvC2CReadReceipt(List<V2TimMessageReceipt> receiptList) {
    print('收到了新消息 已读回执');

    receiptList.forEach((element) {
      print("已读回执${element.userID} ${element.timestamp}");
      Provider.of<CurrentMessageListModel>(context, listen: false)
          .updateC2CMessageByUserId(element.userID);
    });
  }

  onSendMessageProgress(V2TimMessage message, int progress) {
    String key;
    if (message.groupID == null) {
      key = "c2c_${message.userID}";
    } else {
      key = "group_${message.groupID}";
    }
    try {
      Provider.of<CurrentMessageListModel>(
        context,
        listen: false,
      ).addOneMessageIfNotExits(
        key,
        message,
      );
    } catch (err) {
      print("error $err");
    }
    print(
        "消息发送进度 $progress ${message.timestamp} ${message.msgID} ${message.timestamp} ${message.status}");
  }

  onRecvNewMessage(V2TimMessage message) {
    try {
      List<V2TimMessage> messageList = List.empty(growable: true);
      messageList.add(message);
      String key;
      if (message.groupID == null) {
        key = "c2c_${message.sender}";
      } else {
        key = "group_${message.groupID}";
      }
      print("conterkey_$key");
      Provider.of<CurrentMessageListModel>(context, listen: false)
          .addMessage(key, messageList);
    } catch (err) {
      print(err);
    }
  }

  onFriendApplicationListAdded(
    List<V2TimFriendApplication> applicationList,
  ) async {
    List<V2TimFriendApplication> newlist = List.empty(growable: true);
    applicationList.forEach((element) {
      if (element.type != 2) {
        newlist.add(element);
      }
    });
    if (newlist.isNotEmpty) {
      Provider.of<FriendApplicationModel>(context, listen: false)
          .setFriendApplicationResult(newlist);
    }
  }

  onFriendListAddedOronFriendListDeletedOronFriendInfoChangedOronBlackListDeleted() async {
    List<V2TimFriendInfo> nl = List.empty(growable: true);
    V2TimValueCallback<List<V2TimFriendInfo>> friendRes =
        await TencentImSDKPlugin.v2TIMManager
            .getFriendshipManager()
            .getFriendList();
    if (friendRes.code == 0) {
      List<V2TimFriendInfo> newList = friendRes.data;
      if (newList != null && newList.length > 0) {
        Provider.of<FriendListModel>(context, listen: false)
            .setFriendList(newList);
      } else {
        Provider.of<FriendListModel>(context, listen: false).setFriendList(nl);
      }
    }
  }

  onNewConversationOronConversationChanged(
      List<V2TimConversation> conversationList) {
    try {
      Provider.of<ConversionModel>(context, listen: false)
          .setConversionList(conversationList);
      //如果当前会话在使用中，也更新一下

    } catch (e) {}
  }

  onSelfInfoUpdated(V2TimUserFullInfo info) async {
    //自己信息更新，从新获取自己的信息；
    V2TimValueCallback<String> usercallback =
        await TencentImSDKPlugin.v2TIMManager.getLoginUser();
    V2TimValueCallback<List<V2TimUserFullInfo>> infos = await TencentImSDKPlugin
        .v2TIMManager
        .getUsersInfo(userIDList: [usercallback.data]);
    if (infos.code == 0) {
      Provider.of<UserModel>(context, listen: false).setInfo(infos.data[0]);
    }
  }

  onKickedOffline() async {
    // 被踢下线
    // 清除本地缓存，回到登录页TODO
    try {
      Provider.of<ConversionModel>(context, listen: false).clear();
      Provider.of<UserModel>(context, listen: false).clear();
      Provider.of<CurrentMessageListModel>(context, listen: false).clear();
      Provider.of<FriendListModel>(context, listen: false).clear();
      Provider.of<FriendApplicationModel>(context, listen: false).clear();
      Provider.of<GroupApplicationModel>(context, listen: false).clear();
      // 去掉存的一些数据
      Future<SharedPreferences> _prefs = SharedPreferences.getInstance();
      SharedPreferences prefs = await _prefs;
      prefs.remove('token');
      prefs.remove('sessionId');
      prefs.remove('phone');
      prefs.remove('code');
    } catch (err) {
      print("someError");
      print(err);
    }
    print("被踢下线了");
    Navigator.of(context).pushAndRemoveUntil(
      MaterialPageRoute(builder: (BuildContext context) => LoginPage()),
      ModalRoute.withName('/'),
    );
  }

  onReceiveJoinApplicationOronMemberEnter() async {
    //新加群申请
    V2TimValueCallback<V2TimGroupApplicationResult> res =
        await TencentImSDKPlugin.v2TIMManager
            .getGroupManager()
            .getGroupApplicationList();
    if (res.code == 0) {
      if (res.code == 0) {
        if (res.data.groupApplicationList.length > 0) {
          Provider.of<GroupApplicationModel>(context, listen: false)
              .setGroupApplicationResult(res.data.groupApplicationList);
        }
      }
    } else {
      print("获取加群申请失败${res.desc}");
    }
  }

  initSDK() async {
    V2TIMManager timManager = TencentImSDKPlugin.v2TIMManager;

    await timManager.initSDK(
      sdkAppID: 1400187352,
      loglevel: LogLevel.V2TIM_LOG_DEBUG,
      listener: new V2TimSDKListener(
        onConnectFailed: (int code, String error) {
          print("V2TimSDKListener emit type onConnectFailed $code $error");
        },
        onConnectSuccess: () {
          print("V2TimSDKListener emit type onConnectSuccess");
        },
        onConnecting: () {
          print("V2TimSDKListener emit type onConnecting");
        },
        onKickedOffline: () {
          print("V2TimSDKListener emit type onKickedOffline");
          this.onKickedOffline();
        },
        onSelfInfoUpdated: (V2TimUserFullInfo info) {
          print("V2TimSDKListener emit type onSelfInfoUpdated");
          this.onSelfInfoUpdated(info);
        },
        onUserSigExpired: () {
          print("V2TimSDKListener emit type onUserSigExpired");
        },
      ),
    );

    //简单监听
    timManager.addSimpleMsgListener(
      listener: new V2TimSimpleMsgListener(
        onRecvC2CCustomMessage: (
          String msgID,
          V2TimUserInfo sender,
          String customData,
        ) {
          print(
              "V2TimSimpleMsgListener emit type onRecvC2CCustomMessage $msgID ${sender.toJson()} $customData");
        },
        onRecvC2CTextMessage: (
          String msgID,
          V2TimUserInfo sender,
          String text,
        ) {
          print(
              "V2TimSimpleMsgListener emit type onRecvC2CTextMessage $msgID ${sender.toJson()} $text");
        },
        onRecvGroupCustomMessage: (
          String msgID,
          String groupID,
          V2TimGroupMemberInfo sender,
          String customData,
        ) {
          print(
            "V2TimSimpleMsgListener emit type onRecvGroupCustomMessage $msgID ${sender.toJson()} $groupID $customData",
          );
        },
        onRecvGroupTextMessage: (
          String msgID,
          String groupID,
          V2TimGroupMemberInfo sender,
          String text,
        ) {
          print(
            "V2TimSimpleMsgListener emit type onRecvGroupTextMessage $msgID ${sender.toJson()} $text $groupID",
          );
        },
      ),
    );

    //群组监听
    timManager.setGroupListener(
      listener: new V2TimGroupListener(
        onApplicationProcessed: (
          String groupID,
          V2TimGroupMemberInfo opUser,
          bool isAgreeJoin,
          String opReason,
        ) {
          print("V2TimGroupListener emit type onApplicationProcessed");
        },
        onGrantAdministrator: (
          String groupID,
          V2TimGroupMemberInfo opUser,
          List<V2TimGroupMemberInfo> memberList,
        ) {
          print("V2TimGroupListener emit type onGrantAdministrator");
        },
        onGroupAttributeChanged: (
          String groupID,
          Map<String, String> groupAttributeMap,
        ) {
          print("V2TimGroupListener emit type onGroupAttributeChanged");
        },
        onGroupCreated: (
          String groupID,
        ) {
          print("V2TimGroupListener emit type onGroupCreated");
        },
        onGroupDismissed: (
          String groupID,
          V2TimGroupMemberInfo opUser,
        ) {
          print("V2TimGroupListener emit type onGroupDismissed");
        },
        onGroupInfoChanged: (
          String groupID,
          List<V2TimGroupChangeInfo> changeInfos,
        ) {
          print("V2TimGroupListener emit type onGroupInfoChanged");
        },
        onGroupRecycled: (
          String groupID,
          V2TimGroupMemberInfo opUser,
        ) {
          print("V2TimGroupListener emit type onGroupRecycled");
        },
        onMemberEnter: (
          String groupID,
          List<V2TimGroupMemberInfo> memberList,
        ) {
          print("V2TimGroupListener emit type onMemberEnter");
          this.onReceiveJoinApplicationOronMemberEnter();
        },
        onMemberInfoChanged: (
          String groupID,
          List<V2TimGroupMemberChangeInfo> v2TIMGroupMemberChangeInfoList,
        ) {
          print("V2TimGroupListener emit type onMemberInfoChanged");
        },
        onMemberInvited: (
          String groupID,
          V2TimGroupMemberInfo opUser,
          List<V2TimGroupMemberInfo> memberList,
        ) {
          print("V2TimGroupListener emit type onMemberInvited");
        },
        onMemberKicked: (
          String groupID,
          V2TimGroupMemberInfo opUser,
          List<V2TimGroupMemberInfo> memberList,
        ) {
          print("V2TimGroupListener emit type onMemberKicked");
        },
        onMemberLeave: (
          String groupID,
          V2TimGroupMemberInfo member,
        ) {
          print("V2TimGroupListener emit type onMemberLeave");
        },
        onQuitFromGroup: (
          String groupID,
        ) {
          print("V2TimGroupListener emit type onQuitFromGroup");
        },
        onReceiveJoinApplication: (
          String groupID,
          V2TimGroupMemberInfo member,
          String opReason,
        ) {
          print("V2TimGroupListener emit type onReceiveJoinApplication");
          this.onReceiveJoinApplicationOronMemberEnter();
        },
        onReceiveRESTCustomData: (
          String groupID,
          String customData,
        ) {
          print("V2TimGroupListener emit type onReceiveRESTCustomData");
        },
        onRevokeAdministrator: (
          String groupID,
          V2TimGroupMemberInfo opUser,
          List<V2TimGroupMemberInfo> memberList,
        ) {
          print("V2TimGroupListener emit type onRevokeAdministrator");
        },
      ),
    );
    //高级消息监听
    timManager.getMessageManager().addAdvancedMsgListener(
          listener: new V2TimAdvancedMsgListener(
            onRecvC2CReadReceipt: (List<V2TimMessageReceipt> receiptList) {
              print("V2TimAdvancedMsgListener emit type onRecvC2CReadReceipt");
              this.onRecvC2CReadReceipt(receiptList);
            },
            onRecvMessageRevoked: (String msgID) {},
            onRecvNewMessage: (V2TimMessage message) {
              print(
                  "V2TimAdvancedMsgListener emit type onRecvNewMessage ${message.toJson()}");
              this.onRecvNewMessage(message);
            },
            onSendMessageProgress: (message, progress) {
              print("V2TimAdvancedMsgListener emit type onSendMessageProgress");
              this.onSendMessageProgress(message, progress);
            },
          ),
        );
    //关系链监听
    timManager.getFriendshipManager().setFriendListener(
          listener: new V2TimFriendshipListener(
            onBlackListAdd: (infoList) {
              print("V2TimFriendshipListener emit type onBlackListAdd");
            },
            onBlackListDeleted: (userList) {
              print("V2TimFriendshipListener emit type onBlackListDeleted");
              this.onFriendListAddedOronFriendListDeletedOronFriendInfoChangedOronBlackListDeleted();
            },
            onFriendApplicationListAdded: (
              List<V2TimFriendApplication> applicationList,
            ) {
              print(
                  "V2TimFriendshipListener emit type onFriendApplicationListAdded");
              this.onFriendApplicationListAdded(applicationList);
            },
            onFriendApplicationListDeleted: (userIDList) {
              print(
                  "V2TimFriendshipListener emit type onFriendApplicationListDeleted");
            },
            onFriendApplicationListRead: () {
              print(
                  "V2TimFriendshipListener emit type onFriendApplicationListRead");
            },
            onFriendInfoChanged: (infoList) {
              print("V2TimFriendshipListener emit type onFriendInfoChanged");
              this.onFriendListAddedOronFriendListDeletedOronFriendInfoChangedOronBlackListDeleted();
            },
            onFriendListAdded: (users) {
              print("V2TimFriendshipListener emit type onFriendListAdded");
              this.onFriendListAddedOronFriendListDeletedOronFriendInfoChangedOronBlackListDeleted();
            },
            onFriendListDeleted: (userList) {
              print("V2TimFriendshipListener emit type onFriendListDeleted");
              this.onFriendListAddedOronFriendListDeletedOronFriendInfoChangedOronBlackListDeleted();
            },
          ),
        );
    //会话监听
    timManager.getConversationManager().setConversationListener(
          listener: new V2TimConversationListener(
            onConversationChanged: (List<V2TimConversation> conversationList) {
              print(
                  "V2TimConversationListener emit type onConversationChanged");
              this.onNewConversationOronConversationChanged(conversationList);
            },
            onNewConversation: (List<V2TimConversation> conversationList) {
              print("V2TimConversationListener emit type onNewConversation");
              this.onNewConversationOronConversationChanged(conversationList);
            },
            onSyncServerFailed: () {
              print("V2TimConversationListener emit type onSyncServerFailed");
            },
            onSyncServerFinish: () {
              print("V2TimConversationListener emit type onSyncServerFinish");
            },
            onSyncServerStart: () {
              print("V2TimConversationListener emit type onSyncServerStart");
            },
          ),
        );
    timManager.getSignalingManager().addSignalingListener(
            listener: new V2TimSignalingListener(
          onInvitationCancelled: (
            inviteID,
            inviter,
            data,
          ) {
            print(
                "V2TimSignalingListener emit type onInvitationCancelled $inviteID $inviter $data");
          },
          onInvitationTimeout: (
            inviteID,
            inviteeList,
          ) {
            print(
                "V2TimSignalingListener emit type onInvitationTimeout $inviteID $inviteeList ");
          },
          onInviteeAccepted: (
            inviteID,
            invitee,
            data,
          ) {
            print(
              "V2TimSignalingListener emit type onInviteeAccepted $inviteID $invitee $data",
            );
          },
          onInviteeRejected: (
            inviteID,
            invitee,
            data,
          ) {
            print(
              "V2TimSignalingListener emit type onInviteeRejected $inviteID $invitee $data",
            );
          },
          onReceiveNewInvitation: (
            inviteID,
            inviter,
            groupID,
            inviteeList,
            data,
          ) {
            print(
              "V2TimSignalingListener emit type onReceiveNewInvitation $inviteID $inviter $data $groupID $inviteeList",
            );
          },
        ));

    print("初始化完成了");
  }

  @override
  Widget build(BuildContext context) {
    return (!isinit) ? new WaitHomeWidget() : new HomeWidget();
  }
}

class WaitHomeWidget extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => WaitHomeWidgetState();
}

class WaitHomeWidgetState extends State<WaitHomeWidget> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Center(),
    );
  }
}

class HomeWidget extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => HomeWidgetState();
}

class HomeWidgetState extends State<HomeWidget> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: new AppLayout(),
    );
  }
}

class AppLayout extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        AppLogo(),
        Expanded(
          child: LoginForm(),
        )
      ],
    );
  }
}

class AppLogo extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Container(
      height: 192.0,
      color: CommonColors.getThemeColor(),
      alignment: Alignment.topLeft,
      padding: EdgeInsets.only(
        top: 108.0,
      ),
      child: Row(
        children: <Widget>[
          Container(
            height: 90,
            width: 90,
            child: Image(
              image: timLogo,
              width: 90.0,
              height: 90.0,
            ),
          ),
          Container(
            height: 90.0,
            padding: EdgeInsets.only(
              top: 10,
            ),
            child: Column(
              children: <Widget>[
                Text(
                  '登录·即时通信',
                  style: TextStyle(
                    color: Color.fromARGB(255, 255, 255, 255),
                    fontSize: 28,
                  ),
                ),
                Text(
                  '体验群组聊天，音视频对话等IM功能',
                  style: TextStyle(
                    color: Color.fromARGB(255, 255, 255, 255),
                    fontSize: 12,
                  ),
                ),
              ],
              crossAxisAlignment: CrossAxisAlignment.start,
            ),
          )
        ],
      ),
    );
  }
}

class LoginForm extends StatefulWidget {
  _LoginFormState createState() => _LoginFormState();
}

class _LoginFormState extends State<LoginForm> {
  void initState() {
    super.initState();
  }

  bool isGeted = false;
  String tel = '';
  String pwd = '';
  int timer = 60;
  String token = '';
  String sessionId = '';
  TextEditingController userSigEtController = TextEditingController();
  TextEditingController telEtController = TextEditingController();
  void getHttp() async {
    try {
      Response response = await Dio().get(
        "https://service-qr8jjnpm-1256635546.gz.apigw.tencentcs.com/release/getUserSig?userId=xingchenhe",
      );
      print(response);
    } catch (e) {
      print(e);
    }
  }

  timeDown() {
    new Future.delayed(const Duration(milliseconds: 1000), () {
      if (timer == 0) {
        setState(() {
          timer = 60;
          isGeted = false;
        });
        return;
      }
      setState(() {
        timer = --timer;
      });
      timeDown();
    });
  }

  Future<void> showMyDialog() async {
    return showDialog<void>(
      context: context,
      barrierDismissible: false, // user must tap button!
      builder: (BuildContext context) {
        return AlertDialog(
          contentPadding: const EdgeInsets.fromLTRB(0, 0, 0, 0),
          content: SingleChildScrollView(
            child: Container(
              width: 200,
              height: 200,
              child: WebView(
                initialUrl:
                    'https://imgcache.qq.com/operation/dianshi/other/index.e7ef9e022229b9167136a9ed48572f258fe7d528.html',
                javascriptMode: JavascriptMode.unrestricted,
                javascriptChannels: Set.from([
                  JavascriptChannel(
                      name: 'messageHandler',
                      onMessageReceived: (JavascriptMessage message) {
                        var messageObj = jsonDecode(message.message);
                        try {
                          this.sendcode(messageObj);
                          Navigator.pop(context);
                        } catch (e) {}
                      })
                ]),
              ),
            ),
          ),
        );
      },
    );
  }

  void getLoginCode(context) async {
    if (tel.length == 0) {
      Toast.show(
        "请输入正确的手机号码",
        context,
        duration: Toast.LENGTH_SHORT,
        gravity: Toast.TOP,
      );
    } else {
      this.showMyDialog();
    }
  }

  void sendcode(messageObj) async {
    Dio dio = new Dio();
    Response response = await dio.get(
      "https://service-c2zjvuxa-1252463788.gz.apigw.tencentcs.com/release/smsImg",
      queryParameters: {
        "phone": "86${this.tel}",
        "ticket": messageObj['ticket'],
        "randstr": messageObj['randstr']
      },
    );
    print(response);
    try {
      if (response.data['errorCode'] == 0) {
        print(response.data['data']['sessionId']);
      }
      setState(() {
        isGeted = true;
        sessionId = response.data['data']['sessionId'];
      });
      timeDown();
    } catch (err) {
      print(err);
    }
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.fromLTRB(16, 40, 16, 0),
      child: Form(
        child: Column(
          children: [
            TextField(
              autofocus: false,
              controller: telEtController,
              decoration: InputDecoration(
                labelText: "手机号",
                hintText: "请输入手机号码",
                icon: Icon(Icons.phone_android),
              ),
              keyboardType: TextInputType.number,
              onChanged: (v) {
                setState(() {
                  tel = v;
                });
              },
            ),
            Row(
              children: [
                Expanded(
                  child: TextField(
                    controller: userSigEtController,
                    decoration: InputDecoration(
                      labelText: "验证码",
                      hintText: "请输入验证码",
                      icon: Icon(Icons.lock),
                    ),
                    keyboardType: TextInputType.number,
                    //校验密码
                    onChanged: (v) {
                      setState(() {
                        pwd = v;
                      });
                    },
                  ),
                ),
                Container(
                  width: 120,
                  child: RaisedButton(
                    child: isGeted ? Text(timer.toString()) : Text("获取验证码"),
                    color: CommonColors.getThemeColor(),
                    textColor: Colors.white,
                    onPressed: isGeted
                        ? null
                        : () {
                            //获取验证码
                            getLoginCode(context);
                          },
                  ),
                )
              ],
            ),
            Container(
              margin: EdgeInsets.only(
                top: 28,
              ),
              child: Row(
                children: [
                  Expanded(
                    child: RaisedButton(
                      padding: EdgeInsets.only(
                        top: 15,
                        bottom: 15,
                      ),
                      child: Text("登录"),
                      color: CommonColors.getThemeColor(),
                      textColor: Colors.white,
                      onPressed: () async {
                        if (tel == '') {
                          return;
                        }
                        if (pwd == '') {
                          return;
                        }
                        // 获取userSig
                        Dio dio = new Dio();
                        Response response = await dio.get(
                          "https://service-c2zjvuxa-1252463788.gz.apigw.tencentcs.com/release/demoSms",
                          queryParameters: {
                            "phone": "86${this.tel}",
                            "method": "login",
                            "code": pwd,
                            "sessionId": sessionId,
                          },
                        );

                        String userId = response.data['data']['userId'];
                        String userSig = response.data['data']['userSig'];
                        String token = response.data['data']['token'];
                        String avatar = response.data['data']['avatar'];
                        print(response);
                        if (response.data['errorCode'] != 0) {
                          Toast.show(
                            response.data['errorMessage'],
                            context,
                            duration: Toast.LENGTH_SHORT,
                            gravity: Toast.TOP,
                          );
                          return;
                        } else {
                          setState(() {
                            token = token;
                          });
                        }
                        var data = await TencentImSDKPlugin.v2TIMManager.login(
                          userID: userId,
                          userSig: userSig,
                        );

                        if (data.code != 0) {
                          print('登录失败${data.desc}');
                          return;
                        }

                        await Tools.setOfflinepush(context);

                        Future<SharedPreferences> _prefs =
                            SharedPreferences.getInstance();
                        SharedPreferences prefs = await _prefs;
                        prefs.setString("sessionId", sessionId);
                        prefs.setString("token", token);
                        prefs.setString("phone", tel);
                        prefs.setString("code", pwd);
                        V2TimValueCallback<List<V2TimUserFullInfo>> infos =
                            await TencentImSDKPlugin.v2TIMManager
                                .getUsersInfo(userIDList: [userId]);

                        if (infos.code == 0) {
                          if (infos.data[0].nickName == null ||
                              infos.data[0].faceUrl == null ||
                              infos.data[0].nickName == '' ||
                              infos.data[0].faceUrl == '') {
                            await TencentImSDKPlugin.v2TIMManager.setSelfInfo(
                              userFullInfo: V2TimUserFullInfo.fromJson({
                                "nickName": userId,
                                "faceUrl": avatar,
                              }),
                            );
                          }
                          Provider.of<UserModel>(context, listen: false)
                              .setInfo(infos.data[0]);
                        }
                        setState(() {
                          tel = '';
                          pwd = '';
                          timer = 60;
                          isGeted = false;
                        });
                        userSigEtController.clear();
                        telEtController.clear();
                        Navigator.push(
                          context,
                          new MaterialPageRoute(
                            builder: (context) => HomePage(),
                          ),
                        );
                      },
                    ),
                  )
                ],
              ),
            ),
            Expanded(
              child: Container(),
            )
          ],
        ),
      ),
    );
  }
}
