import 'package:tencent_im_sdk_plugin/models/v2_tim_group_change_info.dart';

class V2TimGroupInfoChanged {
  late String groupID;
  late List<V2TimGroupChangeInfo?>? groupChangeInfo;

  V2TimGroupInfoChanged({
    required this.groupID,
    this.groupChangeInfo,
  });

  V2TimGroupInfoChanged.fromJson(Map<String, dynamic> json) {
    groupID = json['groupID'];
    if (json['groupChangeInfo'] != null) {
      groupChangeInfo = List.empty(growable: true);
      json['groupChangeInfo'].forEach((v) {
        groupChangeInfo!.add(new V2TimGroupChangeInfo.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['groupID'] = this.groupID;
    if (this.groupChangeInfo != null) {
      data['groupChangeInfo'] =
          this.groupChangeInfo!.map((v) => v!.toJson()).toList();
    }
    return data;
  }
}
// {
//   "groupID":"",
//   "groupChangeInfo":[{}]
// }
